pipeline {
    environment {
        registry = "vikasharya00/sampledocker0"
        registryCredential = 'dockerhub_id'
        dockerImage = ''

    }
    agent any
    stages {
        stage('Cloning our Git') {
            steps {
                git 'https://gitlab.com/vikash.arya/helloworld.git'
            }
        }
        stage('Building our image') {
            steps {
                script {
                    dockerImage = docker.build registry + ":latest"
                }
            }
        }
        stage('Push our image') {
            steps {
                script {
                    docker.withRegistry( '', registryCredential ) {
                        dockerImage.push()
                    }
                }
            }
        }
        stage('Test containerized app'){
            steps{
                sh "docker run --name=helloworldContainer -d $registry:latest"
                sh "docker stop helloworldContainer"
                sh "docker rm helloworldContainer"
            }
        }
        stage('Cleaning up') {
            steps {
                sh "docker rmi $registry:latest"
            }
        }
        stage('Deploy to kubernetes cluster'){
            steps{
                script{
                    sh "kubectl apply -f helloWorldDeploy.yaml"
                }
            }
        }
    }
}